require 'yarvcore'

$srcdir = File.dirname($0)
require 'rb/insns2vm'
$insns = InsnsDef.new

def insn2c id
  $insns.make_insn($insns.insns[id])
end

def $insns.make_header_operands insn
    vars = @insn_opes[insn]
    n = 0
    ops = []
    
    vars.each_with_index{|(type, var), i|
      if type == '...'
        break
      end

      if type == 'long'
        ops << "#define #{var} INSN_LABEL_#{$operands[i].position }\n"
      else
        ops << "  #{type} #{var} = (#{type})GET_OPERAND(#{i+1});\n"
      end
      n   += 1
    }
    @opn = n
    
    ops.reverse.join
end

def label2c_1 operands, insn_id, idx
  $insns.insn_opes[$insns.insns[insn_id]].each_with_index{|e, i|
    type, var = e

    if type == 'long'
      l = operands[i].position
      puts "#define #{var} #{l+idx}"
    end
  }
end

def label2c_2 operands, insn_id, idx

end

def operand2c op
  case op
  when Fixnum
    "INT2FIX(#{op})"
  when YARVCore::InstructionSequence::Label
    '0'
  else
    raise "unsupport literal: #{op.inspect}"
  end
end

def operands2c operands
  return '' unless operands
  return '' unless operands.size > 0
  
  "VALUE aot_insn_operands[] = {\n" +
  operands.map{|op|
    operand2c(op)
  }.join(",\n") + "};\n"
end

file = File.join(File.dirname($0), 'aotctest.rb')
parsed = YARVCore::parse(File.read(file), file, 1)

puts "/*\n"
puts parsed.disasm.map{|line| " * #{line}"}
puts " */\n"
puts

idx = 0
parsed.insns.each{|insn|
  if insn.kind_of? YARVCore::InstructionSequence::Instruction
    $operands = insn.operands
    $idx      = idx
    puts "INSN_LABEL_#{idx}:"
    puts "{"
    puts operands2c(insn.operands)
    puts insn2c(insn.insn_id)
    puts "}"
    idx += 1 + ($operands ? $operands.size : 0)
  end
}
